Package org.eclipse.lemminx.extensions.xsd.contentmodel

## Class CMXSDDocument

- java.lang.Object
- - org.eclipse.lemminx.extensions.xsd.contentmodel.CMXSDDocument

All Implemented Interfaces:
  `org.apache.xerces.impl.xs.XSElementDeclHelper`, `CMDocument`

    public class CMXSDDocument
    extends Object
    implements CMDocument, org.apache.xerces.impl.xs.XSElementDeclHelper

XSD document implementation.

### Constructor Summary

Constructors
`CMXSDDocument​(org.apache.xerces.xs.XSModel model, org.apache.xerces.impl.xs.XSLoaderImpl xsLoaderImpl)`

### Method Summary

All Methods Instance Methods Concrete Methods
`CMElementDeclaration` `findCMElement​(DOMElement element, String namespace)` Returns the declared element which matches the given XML element and null otherwise.
`org.eclipse.lsp4j.LocationLink` `findTypeLocation​(DOMNode originNode)` Returns the location of the type definition of the given node.
`Collection<CMElementDeclaration>` `getElements()` Returns the elements declaration of the model document root.
`org.apache.xerces.impl.xs.XSElementDecl` `getGlobalElementDecl​(org.apache.xerces.xni.QName element)`
`boolean` `hasNamespace​(String namespaceURI)` Returns true if the model document defines the given namespace and false otherwise.
`boolean` `isDirty()` Returns true if the content model document is dirty and false otherwise.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.eclipse.lemminx.extensions.contentmodel.model.CMDocument

`findCMAttribute, findCMElement, getEntities`

### Constructor Detail

#### CMXSDDocument

    public CMXSDDocument​(org.apache.xerces.xs.XSModel model,
                         org.apache.xerces.impl.xs.XSLoaderImpl xsLoaderImpl)

### Method Detail

#### hasNamespace

    public boolean hasNamespace​(String namespaceURI)

Description copied from interface: `CMDocument`
Returns true if the model document defines the given namespace and false otherwise.

Specified by:
  `hasNamespace` in interface `CMDocument`
Returns:
  true if the model document defines the given namespace and false otherwise.

#### getElements

    public Collection<CMElementDeclaration> getElements()

Description copied from interface: `CMDocument`
Returns the elements declaration of the model document root.

Specified by:
  `getElements` in interface `CMDocument`
Returns:
  the elements declaration of the model document root.

#### findCMElement

    public CMElementDeclaration findCMElement​(DOMElement element,
                                              String namespace)

Description copied from interface: `CMDocument`
Returns the declared element which matches the given XML element and null otherwise.

Specified by:
  `findCMElement` in interface `CMDocument`
Parameters:
  `element` - the XML element
  `namespace` - the given namespace
Returns:
  the declared element which matches the given XML element and null otherwise.

#### getGlobalElementDecl

    public org.apache.xerces.impl.xs.XSElementDecl getGlobalElementDecl​(org.apache.xerces.xni.QName element)

Specified by:
  `getGlobalElementDecl` in interface `org.apache.xerces.impl.xs.XSElementDeclHelper`

#### findTypeLocation

    public org.eclipse.lsp4j.LocationLink findTypeLocation​(DOMNode originNode)

Description copied from interface: `CMDocument`
Returns the location of the type definition of the given node.

Specified by:
  `findTypeLocation` in interface `CMDocument`
Parameters:
  `originNode` - the node
Returns:
  the location of the type definition of the given node.

#### isDirty

    public boolean isDirty()

Description copied from interface: `CMDocument`
Returns true if the content model document is dirty and false otherwise.

Specified by:
  `isDirty` in interface `CMDocument`
Returns:
  true if the content model document is dirty and false otherwise.